/**

    Copyright 2007 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/
package it.eng.console.attachment.action;

import it.eng.console.audit.bo.ProcessInstanceBO;
import it.eng.spago.base.SourceBean;
import it.eng.spago.dispatching.action.AbstractAction;

import org.spagic.metadb.model.TransitionInstance;

public class AttachmentAction extends AbstractAction {

	public void service(SourceBean serviceRequest, SourceBean serviceResponse)
			throws Exception {
		String idJournal = (String)serviceRequest.getAttribute("idJournal");
		TransitionInstance transitionInstance = ProcessInstanceBO.getTransitionInstance(Long.parseLong(idJournal));
		
		SourceBean attachment = null;
		if (transitionInstance.getAttachmentIn() != 0) {
			attachment = new SourceBean("ATTACHMENT_IN");
			attachment.setAttribute("number", transitionInstance.getAttachmentIn());	
			attachment.setAttribute("idJournal", idJournal);
			serviceResponse.setAttribute(attachment);
		}
		if (transitionInstance.getAttachmentOut() != 0) {
			attachment = new SourceBean("ATTACHMENT_OUT");
			attachment.setAttribute("number", transitionInstance.getAttachmentIn());	
			attachment.setAttribute("idJournal", idJournal);
			serviceResponse.setAttribute(attachment);
		}
		
	}

}
