/**

Copyright 2004, 2007 Engineering Ingegneria Informatica S.p.A.

This file is part of Spago.

Spago is free software; you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation; either version 2.1 of the License, or
any later version.

Spago is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with Spago; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

**/

package it.eng.console.tag;

import it.eng.console.util.Constants;
import it.eng.spago.base.RequestContainer;
import it.eng.spago.base.RequestContainerAccess;
import it.eng.spago.tracing.TracerSingleton;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.jsp.JspException;
import javax.servlet.jsp.tagext.TagSupport;

/**
 * @author Butano
 */
public class LanguageCodeCalendarTag extends TagSupport {

	public LanguageCodeCalendarTag() {
		super();
	}
	
	public int doStartTag() throws JspException {
        TracerSingleton.log(Constants.project, TracerSingleton.INFORMATION, "LanguageCodeCalendarTag::doStartTag:: invocato");        
        HttpServletRequest httpRequest = null;
        try {
            httpRequest = (HttpServletRequest) pageContext.getRequest();
        } catch(Exception ex) {
            TracerSingleton.log(
            		Constants.project, TracerSingleton.CRITICAL, "OrganizationComboTag::doStartTag::", ex);
            throw new JspException(ex.getMessage());
        } 

        RequestContainer requestContainer =
            RequestContainerAccess.getRequestContainer(httpRequest);
        StringBuffer htmlStream = new StringBuffer();
        htmlStream.append("<script>");
        if (((String)requestContainer.getSessionContainer().getPermanentContainer().getAttribute("AF_LANGUAGE")).equals("it")) {
        	 htmlStream.append("var languageCode='it';");
        	 htmlStream.append("var formatData='dd/mm/yyyy hh:ii';");
        } else {
			htmlStream.append("var languageCode='en';");
			htmlStream.append("var formatData='mm/dd/yyyy hh:ii';");
		}
        htmlStream.append("</script>");
        try {
            pageContext.getOut().print(htmlStream);
        } 
        catch (Exception ex) {
            TracerSingleton.log(Constants.project, TracerSingleton.CRITICAL,
                "LanguageCodeCalendarTag::doStartTag:: Impossibile inviare lo stream");
            throw new JspException("Impossibile inviare lo stream");
        } 
        return SKIP_BODY;
	}

	public int doEndTag() throws JspException {
        TracerSingleton.log(Constants.project, TracerSingleton.INFORMATION, "LanguageCodeCalendarTag::doEndTag:: invocato");
        return super.doEndTag();
    }

}
