/**

    Copyright 2007 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/
package it.eng.console.tag.menu;

import it.eng.console.util.Constants;
import it.eng.spago.message.MessageBundle;
import it.eng.spago.tracing.TracerSingleton;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.jsp.JspException;
import javax.servlet.jsp.tagext.TagSupport;

public class BaseMenuTag extends TagSupport {
	
	private static final long serialVersionUID = 1L;
	private static final int ICON_SIZE = 32;
	
    public int doStartTag() throws JspException {
        TracerSingleton.log(Constants.project, TracerSingleton.DEBUG, "BaseMenuTag::doStartTag:: invocato");
        if(pageContext == null) {
            TracerSingleton.log(Constants.project, TracerSingleton.CRITICAL,
                "BaseMenuTag::doStartTag:: pageContext nullo");
            throw new JspException("pageContext nullo");
        } 
        HttpServletRequest httpRequest = null;
        try {
            httpRequest = (HttpServletRequest) pageContext.getRequest();
        } catch(Exception ex) {
            TracerSingleton.log(
            		Constants.project, TracerSingleton.CRITICAL, "BaseMenuTag::doStartTag::", ex);
            throw new JspException(ex.getMessage());
        } 
        if(httpRequest == null) {
            TracerSingleton.log(Constants.project, TracerSingleton.CRITICAL, "BaseMenuTag::doStartTag:: httpRequest nullo");
            throw new JspException("httpRequest nullo");
        } 
        String context = httpRequest.getContextPath();
        
        StringBuffer output = new StringBuffer();
        int xCoord = 18;
        output.append("<div style=\"position:absolute;left:" + xCoord + "px;\">\n");
        output.append("<a href=\"" + context + "/servlet/AdapterHTTP?ACTION_NAME=ProcessListFilteredAction\">\n");
        output.append("<img src=\"" + context + "/images/console/process.gif\"\n");
        output.append("title=\"" + MessageBundle.getMessage("processList", "properties.spagic") + "\"\n");
        output.append("alt=\"" + MessageBundle.getMessage("processList", "properties.spagic") + "\"/>\n");
        output.append("</a>\n");
        output.append("</div>\n");
        
        xCoord += ICON_SIZE;
        output.append("<div style=\"position:absolute;left:" + xCoord + "px;\">\n");
        output.append("<a href=\"" + context + "/servlet/AdapterHTTP?ACTION_NAME=ProcessInstanceListFilteredAction\">\n");
        output.append("<img src=\"" + context + "/images/console/instance.gif\"\n");
        output.append("title=\"" + MessageBundle.getMessage("processInstanceList", "properties.spagic") + "\"\n");
        output.append("alt=\"" + MessageBundle.getMessage("processInstanceList", "properties.spagic") + "\"/>\n");
        output.append("</a>\n");
        output.append("</div>\n");
        
        xCoord += ICON_SIZE;
        output.append("<div style=\"position:absolute;left:" + xCoord + "px;\">\n");
        output.append("<a href=\"" + context + "/servlet/AdapterHTTP?ACTION_NAME=MessagesSearchAction\">\n");
        output.append("<img src=\"" + context + "/images/console/message.png\"\n");
        output.append("title=\"" + MessageBundle.getMessage("messagesSearch", "properties.spagic") + "\"\n");
        output.append("alt=\"" + MessageBundle.getMessage("messagesSearch", "properties.spagic") + "\"/>\n");
        output.append("</a>\n");
        output.append("</div>\n");
        
        xCoord += ICON_SIZE;
        output.append("<div style=\"position:absolute;left:" + xCoord + "px;\">\n");
        output.append("<a href=\"" + context + "/servlet/AdapterHTTP?ACTION_NAME=BAMGraphsAction\">\n");
        output.append("<img src=\"" + context + "/images/console/chart_bar.png\"\n");
        output.append("title=\"" + MessageBundle.getMessage("showGraphs", "properties.spagic") + "\"\n");
        output.append("alt=\"" + MessageBundle.getMessage("showGraphs", "properties.spagic") + "\"/>\n");
        output.append("</a>\n");
        output.append("</div>\n");
        
        xCoord += ICON_SIZE;
        output.append("<div style=\"position:absolute;left:" + xCoord + "px;\">\n");
        output.append("<img src=\"" + context + "/images/console/sepMenu.gif\"/>\n");
        output.append("</div>\n");
        
        xCoord += ICON_SIZE;
        output.append("<div style=\"position:absolute;left:" + xCoord + "px;\">\n");
        output.append("<a href=\"" + context + "/servlet/AdapterHTTP?ACTION_NAME=SummaryAction\">\n");
        output.append("<img src=\"" + context + "/images/console/server.png\"\n");
        output.append("title=\"" + MessageBundle.getMessage("system", "properties.spagic") + "\"\n");
        output.append("alt=\"" + MessageBundle.getMessage("system", "properties.spagic") + "\"/>\n");
        output.append("</a>\n");
        output.append("</div>\n");
        
        xCoord += ICON_SIZE;
        output.append("<div style=\"position:absolute;left:" + xCoord + "px;\">\n");
        output.append("<a href=\"" + context + "/servlet/AdapterHTTP?ACTION_NAME=QueueAction\">\n");
        output.append("<img src=\"" + context + "/images/console/queue.gif\"\n");
        output.append("title=\"" + MessageBundle.getMessage("queue", "properties.spagic") + "\"\n");
        output.append("alt=\"" + MessageBundle.getMessage("queue", "properties.spagic") + "\"/>\n");
        output.append("</a>\n");
        output.append("</div>\n");
        
        xCoord += ICON_SIZE;
        output.append("<div style=\"position:absolute;left:" + xCoord + "px;\">\n");
        output.append("<a href=\"" + context + "/servlet/AdapterHTTP?ACTION_NAME=WaitListAction\">\n");
        output.append("<img src=\"" + context + "/images/console/clock.png\"\n");
        output.append("title=\"" + MessageBundle.getMessage("processWaitingList", "properties.spagic") + "\"\n");
        output.append("alt=\"" + MessageBundle.getMessage("processWaitingList", "properties.spagic") + "\"/>\n");
        output.append("</a>\n");
        output.append("</div>\n");
        try {
            pageContext.getOut().print(output.toString());
        } catch(Exception ex) {
            TracerSingleton.log(Constants.project, TracerSingleton.CRITICAL, "BaseMenuTag::doStartTag::", ex);
            throw new JspException(ex.getMessage());
        } 
        return SKIP_BODY;
    } 

	/**
     * @see javax.servlet.jsp.tagext.Tag#doEndTag()
     */
    public int doEndTag() throws JspException {
        TracerSingleton.log(Constants.project, TracerSingleton.DEBUG, "OrganizationComboTag::doEndTag:: invocato");
        return super.doEndTag();
    } 
}
