package it.eng.console.util;

import it.eng.spago.base.SessionContainer;
import it.eng.spago.tracing.TracerSingleton;

import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Locale;

public class DateFormatter {

	public static Date toDate(String date, SessionContainer sessionContainer) {
		SimpleDateFormat simpleDateFormat = null;
		if (((String)sessionContainer.getPermanentContainer().getAttribute("AF_LANGUAGE")).equals("it"))
			simpleDateFormat = new SimpleDateFormat("dd/MM/yyyy HH:mm");
		else
			simpleDateFormat = new SimpleDateFormat("MM/dd/yyyy HH:mm");
		Date result = null;
		try {
			result = simpleDateFormat.parse(date);			
		} catch(Exception npe) {
			TracerSingleton.log(Constants.project, TracerSingleton.DEBUG, "DateFormatter::toSate: date null");
		}
		return result;
	}
	
	public static DateFormat getShortDateTimeFormat(SessionContainer sessionContainer) {
		Locale locale = getLocal(sessionContainer);
		return DateFormat.getDateTimeInstance(DateFormat.SHORT, DateFormat.SHORT, locale);
	}
	
	public static DateFormat getShortDateFormat(SessionContainer sessionContainer) {
		Locale locale = getLocal(sessionContainer);
		return DateFormat.getDateInstance(DateFormat.SHORT, locale);
	}
	
	public static DateFormat getShortTimeFormat(SessionContainer sessionContainer) {
		Locale locale = getLocal(sessionContainer);
		return DateFormat.getTimeInstance(DateFormat.SHORT, locale);
	}
	
	public static Locale getLocal(SessionContainer sessionContainer) {
		if (((String)sessionContainer.getPermanentContainer().getAttribute("AF_LANGUAGE")).equals("it"))
			return Locale.ITALY;
		else 
			return Locale.ENGLISH;
	}
}
