package it.eng.spago.services;

import it.eng.spago.base.SourceBean;

/**
 * Interface to be implemented by any service that is in the service catalog.
 * 
 * Managed scopes are <code>REQUEST, SESSION, APPLICATION</code>
 */
//public interface ServiceInterface extends RuntimeUserInterface {
public interface ServiceInterface {
	
	/**
	 * Method used to initialize a service after its instantiation.
	 * @param config. A <code>SourceBean</code> containing configuration attributes.
	 * @throws Exception on any error
	 */
	//  public void init(Properties props) throws ServiceException;
	// TODO check if you can throw a specific exception
	public void init(SourceBean config) throws Exception;
	
	/**
	 * Return the lifecycle scope of this service.
	 * 
	 * @return
	 */
	public String getScope();
	
	/**
	 * Set the lifecycle scope of this service.
	 * 
	 * @param scope.
	 */
	public void setScope(String scope);
}
